VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   1125
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2775
   LinkTopic       =   "Form1"
   ScaleHeight     =   1125
   ScaleWidth      =   2775
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Lock - then shutdown"
      Height          =   315
      Left            =   180
      TabIndex        =   0
      Top             =   600
      Width           =   2415
   End
   Begin VB.Timer tmrShutDown 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   1140
      Top             =   60
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Original code for shutdown:
' By: Alexandru Ionescu
' http://www.Planet-Source-Code.com/vb/scripts/ShowCode.asp?txtCodeId=53100&lngWId=1
' Returns:A closed PC.
'
' Side Effects:Nothing will be saved, in
'     stant shutdown.

Option Explicit
'To shut ddown, you may also try the following:
Private Const EWX_LOGOFF = &H0       ' Shuts down all processes running in the security context of the process that called the ExitWindowsEx function. Then it logs the user off.
Private Const EWX_POWEROFF = &H8     ' Shuts down the system and turns off the power. The system must support the power-off feature. The calling process must have the SE_SHUTDOWN_NAME privilege. For more information, see the following Remarks section.
Private Const EWX_REBOOT = &H2       ' Shuts down the system and then restarts the system. The calling process must have the SE_SHUTDOWN_NAME privilege. For more information, see the following Remarks section.
Private Const EWX_SHUTDOWN = &H1     ' Shuts down the system to a point at which it is safe to turn off the power. All file buffers have been flushed to disk, and all running processes have stopped. The calling process must have the SE_SHUTDOWN_NAME privilege. For more information, see the following Remarks section.  Specifying this flag will not shut down the power to the system even if it supports the power-off feature. You must specify EWX_POWEROFF to do this.
Private Const EWX_FORCE = &H4        ' Forces processes to terminate. When this flag is set, the system does not send the WM_QUERYENDSESSION and WM_ENDSESSION messages. This can cause the applications to lose data. Therefore, you should only use this flag in an emergency.
'              ' Windows XP: If the computer is locked and this flag is not specified, the shutdown process will fail.
Private Const EWX_FORCEIFHUNG = &H10 ' Forces processes to terminate if they do not respond to the WM_QUERYENDSESSION or WM_ENDSESSION message. This flag is ignored if EWX_FORCE is used.
'              ' Windows NT and Windows Me/98/95:  This value is not supported.
'
Private Declare Function ExitWindowsEx Lib "USER32.DLL" (ByVal uFlags As Long, ByVal dwReason As Long) As Long
Const SE_SHUTDOWN_PRIVILEGE As Long = 19
Const SHUTDOWN As Long = 0
Const RESTART As Long = 1
Const POWEROFF As Long = 2
Private Declare Function RtlAdjustPrivilege Lib "ntdll" ( _
                  ByVal Privilege As Long _
                , ByVal NewValue As Long _
                , ByVal NewThread As Long _
                , OldValue As Long _
                ) As Long
               
Private Declare Function NtShutdownSystem Lib "ntdll" ( _
                ByVal ShutdownAction As Long _
                ) As Long
Private Declare Function LockWorkStation Lib "USER32.DLL" () As Long

Private Sub Command1_Click()
    tmrShutDown.Enabled = True
    LockWorkStation
End Sub

Private Sub tmrShutDown_Timer()
    tmrShutDown.Enabled = False
    RtlAdjustPrivilege SE_SHUTDOWN_PRIVILEGE, 1, 0, 0
    If ExitWindowsEx(EWX_FORCE, 0) = 0 Then
        NtShutdownSystem SHUTDOWN
   End If
    
End Sub

Private Sub Form_Load()
    tmrShutDown.Enabled = False
End Sub


'
'Private Sub Form_Load()
'   If ExitWindowsEx(EWX_LOGOFF, 0) = 0 Then
'      MsgBox "The following error occured while trying to log off Windows:" & Chr(13) & Chr(13) & "Error Number = " & Err.LastDllError, vbOKOnly + vbExclamation, " "
'   End If
'End Sub

